## maint-guide 1.2.31

=== Makefile ===
##############################################################################
# Makefile for the Debian New Maintainers' Guide
##############################################################################

# Note: This Makefile should work perfectly without the debian/ directory.

# Required packages for building documentation source
# basic:		xsltproc, docbook-xsl (These are dependency of dblatex)
# i18n:			po4a
# plain text conv.:	w3m
# pdf via pdflatex:	dblatex, ghostscript, lmodern, texlive-lang-*
# pdf via xelatex:	texlive-xelatex, (ttf-font-packages)

##############################################################################
# Package specific customization
##############################################################################
# package name
MANUAL		:= maint-guide
# common inclusion entity files (excluding version)
COMMON_ENT	:= common.ent
# format to be built
FORMATS		:= html txt pdf
##############################################################################
# PDF build tool customization for each lunguage
##############################################################################
# languages supported by direct DocBook files (always: en)
LANGS_EN	:= en
# languages supported by translation PO files
LANGS_PO	:= ca de es fr it ja ru de zh-cn zh-tw
# ca: 99%
# de: 24%
# es: 97%
# fr: 100%
# it: 100%
# ja: 100%
# ru: 100%
# zh-cn: 33%
# zh-tw:28%
# 
# dblatex is used as the default PDF build tool
# No PDF build for these lunguages (in case of error, use this as work around)
LANGS_NOPDF		:= 
# all languages to build
LANGS		:= $(LANGS_EN) $(LANGS_PO)
# local script file directory
SCRIPT		:= script
# translation contents directory such as PO file
PO4A		:= po4a
# The translation threshold percent should be 80, if translation is completed.
THRESHOLD	:= 0
# XSLT (Extensible Stylesheet Language Transformations) file directory
XSLT		:= xslt
# manual publish directory
ifeq ($(PUBLISHDIR),)
# local test build
MANUALDIR	:= $(CURDIR)/html
else
# www-master.debian.org build script.
MANUALDIR       := $(abspath $(PUBLISHDIR)/$(MANUAL))
endif
XTMPDIR	:= $(CURDIR)/tmp
# CSS (Cascading Style Sheets) file
CSS		:= $(MANUAL).css
# Image files
IMAGES		:= caution.png home.gif important.png next.gif note.png prev.gif tip.png up.gif warning.png draft.png
IMAGESSRC	:= /usr/share/xml/docbook/stylesheet/nwalsh/images
IMAGESDIR	:= $(MANUALDIR)/images

# install
install_file	:= install -p -m 664
install_dir	:= install -d -m 2775

# Change $(DRAFTMODE) from "yes" to "maybe" when this $(MANUAL) should go into
# production mode
#DRAFTMODE      := yes
DRAFTMODE       := maybe
export DRAFTMODE
##############################################################################
# PO update
##############################################################################
# Usually, POMODE =  update|static
POMODE	:= static

##############################################################################
# build tool customization for debug etc.
##############################################################################
XP		:= xsltproc --nonet --novalid --xinclude
XL		:= xmllint --nonet --noout --postvalid --xinclude
# Set $(DEBUG) to activate debug mode
ifeq ($(DEBUG),)
DBLATEX		:= dblatex
else
DBLATEX		:= dblatex --verbose --dump --debug
endif
##############################################################################
# Basic phony targets
##############################################################################
.PHONY: all build build-indep
all: build

build: build-indep

build-indep:	$(foreach lng,$(LANGS), $(foreach fmt, $(filter-out html, $(FORMATS)), $(MANUAL).$(lng).$(fmt))) \
		$(foreach lng,$(LANGS), $(foreach fmt, $(filter     html, $(FORMATS)),     index.$(lng).html))

##############################################################################
# Utility phony targets
##############################################################################
.PHONY: dbk dbk-orig txt html pdf po pot
txt:	$(foreach lng,$(LANGS), $(MANUAL).$(lng).txt)
html:	$(foreach lng,$(LANGS), index.$(lng).html)
pdf:	$(foreach lng,$(LANGS), $(MANUAL).$(lng).pdf)
po:
	touch $(MANUAL).en.dbk
	$(MAKE) $(foreach lng, $(LANGS_PO), $(PO4A)/$(MANUAL).$(lng).po) POMODE=update
pot:	$(PO4A)/$(MANUAL).pot
dbk:	$(foreach lng,$(LANGS_PO), $(MANUAL).$(lng).dbk)

##############################################################################
# Conditional branching variable
##############################################################################
# Conditional branching of build process is implimented by recursively calling
# this Makefile.  The first level executon of this Makefile calls $(MAKE) with
# the controlling variable $(LINGUA).  The second level executon of this
# Makefile uses $(LINGUA) as conditional branching.  Initial value of $(LINGUA)
# is "".
LINGUA		:=

##############################################################################
# Version file preparations
##############################################################################
# version from debian/changelog
ifeq ($(PUBLISHDIR),)
# if not for www-master (e.g., package building)
version.ent:
	echo "<!ENTITY docisodate \"$(shell LC_ALL=C date -u +'%F %T %Z')\">" > version.ent
	[ -r debian/changelog ] && \
	echo "<!ENTITY docversion \"$(shell LC_ALL=C dpkg-parsechangelog | grep '^Version: ' | sed 's/^Version: *//')\">" >> version.ent ||\
	echo "<!ENTITY docversion \"unknown version\">" >> version.ent
else
# if for www-master directly building from subversion source 
version.ent:
	echo "<!ENTITY docisodate \"$(shell LC_ALL=C date -u +'%F %T %Z')\">" > version.ent
	[ -r debian/changelog ] && \
	echo "<!ENTITY docversion \"$(shell LC_ALL=C dpkg-parsechangelog | grep '^Version: ' | sed 's/^Version: *//')-svn\">" >> version.ent ||\
	echo "<!ENTITY docversion \"unknown version\">" >> version.ent
endif
##############################################################################
# DocBook XML source file preparations
##############################################################################
$(MANUAL).en.dbk:
	# This is source
	@true

# Generate base localized DocBook XML files for all non-"en"
# This does not depend on $(PO4A)/$(MANUAL).%.po intentionally 
# to aviod automatic update of $(PO4A)/$(MANUAL).%.po.
$(MANUAL).%.dbk: $(MANUAL).en.dbk $(PO4A)/$(MANUAL).%.ent $(PO4A)/$(MANUAL).%.po
	po4a-translate --format docbook --keep $(THRESHOLD) --master-charset UTF-8 \
		--master $< --po $(PO4A)/$(MANUAL).$*.po --localized $@ ;\
	sed -i -e 's/$(PO4A)\/$(MANUAL)\.en\.ent/$(PO4A)\/$(MANUAL).$*.ent/' $@ ;\

##############################################################################
# DocBook PO source file preparations
##############################################################################
ifeq ($(POMODE),update)
# Always update localized PO files while making PO template(pot) as needed
# .PHONY as follows does not work nicely with %, thus FORCE is used here.
#.PHONY: $(foreach lng, $(LANGS_PO), $(PO4A)/$(MANUAL).$(lng).po)
$(PO4A)/$(MANUAL).%.po: FORCE
	$(MAKE) $(PO4A)/$(MANUAL).pot
	msgmerge --update --previous $@ $(PO4A)/$(MANUAL).pot
else

$(PO4A)/$(MANUAL).%.po: FORCE
	: # do nothing
endif

# Generate PO template(pot) file from English DocBook XML file
# make sure no location line for easier merge.
$(PO4A)/$(MANUAL).pot: $(MANUAL).en.dbk
	po4a-gettextize --format docbook --master-charset UTF-8 --master $< |\
	msgcat --no-location - > $@

##############################################################################
# Plain text building
##############################################################################
# Generate formatted output in single page plain text
# txt.xsl provide work around for hidden URL links by appending them explicitly.
$(MANUAL).%.txt: $(MANUAL).%.dbk $(COMMON_ENT)
	[ -e version.ent ] || $(MAKE) version.ent
	@test -n "`which w3m`"  || { echo "E: w3m not found. Please install the w3m package." ; false ;  }
	$(XP) $(XSLT)/txt.xsl $< |\
		LC_ALL=C.UTF-8 w3m -o display_charset=UTF-8 -cols 70 -dump -no-graph -T text/html > $@

##############################################################################
# HTML text building
##############################################################################
# Generate formatted output in multi-page html text
index.%.html: $(MANUAL).%.dbk $(COMMON_ENT)
	[ -e version.ent ] || $(MAKE) version.ent
	$(XP) --stringparam draft.mode $(DRAFTMODE) \
		--stringparam root.filename index \
                --stringparam html.ext .$*.html \
                --stringparam html.stylesheet $(MANUAL).css \
		$(XSLT)/html.xsl $<

##############################################################################
# PDF building (conditional)
##############################################################################

ifeq ($(LINGUA),)
# if $(LINGUA) is "" (unset == inital call)

$(MANUAL).%.pdf: $(MANUAL).%.dbk $(COMMON_ENT)
	[ -e version.ent ] || $(MAKE) version.ent
	# This calls itself while setting LINGUA (conditional trick) for $@
	make "LINGUA=$*" $@

$(MANUAL).%.tex: $(MANUAL).%.dbk $(COMMON_ENT)
	[ -e version.ent ] || $(MAKE) version.ent
	# This calls itself while setting LINGUA (conditional trick) for $@
	make "LINGUA=$*" $@

else ifeq ($(filter-out $(LANGS_NOPDF),$(LINGUA)),)
# if $(LINGUA) belongs to $(LANGS_NOPDF)

$(MANUAL).$(LINGUA).pdf: $(MANUAL).$(LINGUA).dbk $(COMMON_ENT)
	echo "PDF building for $(LINGUA) currently disabled." > $@

else
# build with xelatex backend

$(MANUAL).$(LINGUA).pdf: $(MANUAL).$(LINGUA).dbk $(COMMON_ENT)
	@test -n "`which $(DBLATEX)`"  || { echo "E: dblatex not found. Please install the dblatex package." ; false ;  }
	@mkdir -p $(XTMPDIR)
	export TMPDIR=$(XTMPDIR) ; \
	export TEXINPUTS=".:" ; \
	$(XP) $(XSLT)/dblatex.xsl $<  | \
	$(DBLATEX) --style=db2latex \
		--backend=xetex \
		--xsl-user=$(XSLT)/user_param.xsl \
		--xsl-user=$(XSLT)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=lingua=$(LINGUA) \
		--output=$@ -

$(MANUAL).$(LINGUA).tex: $(MANUAL).$(LINGUA).dbk $(COMMON_ENT)
	@test -n "`which $(DBLATEX)`"  || { echo "E: dblatex not found. Please install the dblatex package." ; false ;  }
	@mkdir -p $(XTMPDIR)
	export TMPDIR=$(XTMPDIR) ; \
	export TEXINPUTS=".:"; \
	$(XP) $(XSLT)/dblatex.xsl $<  | \
	$(DBLATEX) --style=db2latex \
		--type=tex \
		--backend=xetex \
		--xsl-user=$(XSLT)/user_param.xsl \
		--xsl-user=$(XSLT)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=lingua=$(LINGUA) \
		--output=$@ -

endif

##############################################################################
# This rule controls the build and installation on the website
# Logs are here: http://www-master.debian.org/build-logs/ddp/
# For web page building (publish)
# this can and will be overriden by a higher level makefile
##############################################################################
.PHONY: publish
publish:
	# next lines are for transition
	-$(MAKE) clean
	# real publish target
	-rm -f version.ent
	$(MAKE) version.ent
	$(MAKE) html txt pdf
	[ -d $(IMAGESDIR) ] || $(install_dir) $(IMAGESDIR)
	$(install_file) *.html		$(MANUALDIR)
	$(install_file) $(MANUAL).*.txt $(MANUALDIR)
	$(install_file) $(MANUAL).*.pdf $(MANUALDIR)
	$(install_file) $(CSS) 		$(MANUALDIR)
	echo "AddCharset UTF-8 .txt" > $(MANUALDIR)/.htaccess
	$(install_file) $(addprefix $(IMAGESSRC)/, $(IMAGES)) $(IMAGESDIR)

##############################################################################
# Special utility targets used only by the maintainer
##############################################################################
.PHONY:	tw
# Translate from zh-cn to zh-tw (semi-automatic)
tw:
	msgcat --no-wrap $(PO4A)/$(MANUAL).zh-cn.po | opencc | sed -f $(BIN)/cn2tw.sed | msgcat - > $(PO4A)/$(MANUAL).zh-tw.po

# phony targets for PO maintainances
.PHONY:  tidypo
tidypo:
	for f in $(LANGS_PO); do msgcat --no-location $(PO4A)/$(MANUAL).$$f.po | sponge $(PO4A)/$(MANUAL).$$f.po ; done

=== debian/changelog ===
maint-guide (1.2.31) unstable; urgency=low

  * Correct ML reference to debian-devel-changes. Closes: #671703
  * Correct URL links. Closes: #678041, #692210
  * Document dh_link(1) and debian/links debian/symbols, --with gir.
    and shared libraries. Closes: #668935, #691094
  * Updated translations: ja fr it es ca ru Closes: #688243, #696255 

 -- Osamu Aoki <osamu@debian.org>  Mon, 24 Dec 2012 23:32:31 +0900

=== debian/control ===
Source: maint-guide
Section: doc
Priority: optional
Maintainer: Osamu Aoki <osamu@debian.org>
Uploaders: Josip Rodin <joy-packages@debian.org>
Build-Depends: debhelper (>= 8.0.0)
Build-Depends-Indep: 
 dblatex,
 docbook-xml,
 docbook-xsl, 
 po4a,
 texlive-xetex,
 texlive-lang-spanish,
 texlive-lang-french,
 texlive-lang-italian,
 texlive-lang-cyrillic,
 lmodern,
 tipa,
 gsfonts,
 fonts-ipafont,
 w3m,
 ghostscript, 
 xsltproc
# texlive-lang-german,
# ttf-arphic-gbsn00lp,
# ttf-arphic-bsmi00lp,
# ttf-wqy-zenhei,
Standards-Version: 3.9.3
Homepage: http://www.debian.org/doc/devel-manuals#maint-guide
Vcs-Svn: svn://svn.debian.org/svn/ddp/manuals/trunk/maint-guide
Vcs-Browser: http://svn.debian.org/viewsvn/ddp/manuals/trunk/maint-guide/

Package: maint-guide
Architecture: all
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package

Package: maint-guide-ca
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (Catalan)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is Catalan translation.

Package: maint-guide-es
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (Spanish)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is Spanish translation.

Package: maint-guide-fr
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (French)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is French translation.

Package: maint-guide-it
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (Italian)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is Italian translation.

Package: maint-guide-ja
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (Japanese)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is Japanese translation.

Package: maint-guide-ru
Architecture: all
Priority: extra
Depends: ${misc:Depends}
Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
Description: Debian New Maintainers' Guide (Russian)
 This package contains the Debian New Maintainers' Guide.
 .
 This document tries to describe the building of a Debian package to ordinary
 Debian users and prospective developers. It uses fairly non-technical
 language, and it's well covered with working examples.
 .
 The document contains these chapters:
     * 1 Getting started The Right Way
     * 2 First steps
     * 3 Modifying the source
     * 4 Required files under debian directory
     * 5 Other files under debian directory
     * 6 Building the package
     * 7 Checking the package for errors
     * 8 Uploading the package
     * 9 Updating the package
 .
 This is Russian translation.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEBIAN_DIR	:= $(CURDIR)/debian
MANUAL		:= maint-guide

# Language which is the base of all files
LANGS_EN	:= en

# Languages which generate DocBook XML files from PO files
LANGS_PO        := ca es fr it ja ru
# ca: 99%
# de: 24%
# es: 97%
# fr: 100%
# it: 100%
# ja: 100%
# ru: 100%
# zh-cn: 33%
# zh-tw:28%

# Override main Makefile to build CJK under sid
# No PDF build for these lunguages
LANGS_NOPDF            :=  

# Language groups
LANGS		:= $(LANGS_EN) $(LANGS_PO)
#######################################################################
prep:
	-rm -f $(DEBIAN_DIR)/*.install $(DEBIAN_DIR)/*.doc-base $(DEBIAN_DIR)/*.lintian-overrides
	sed -e '/^Package: maint-guide-/,$$d' <$(DEBIAN_DIR)/control | sponge $(DEBIAN_DIR)/control
	$(DEBIAN_DIR)/language "en" < $(DEBIAN_DIR)/template/install > $(DEBIAN_DIR)/$(MANUAL).install
	$(DEBIAN_DIR)/language "en" < $(DEBIAN_DIR)/template/doc-base > $(DEBIAN_DIR)/$(MANUAL).doc-base
	$(DEBIAN_DIR)/language "en" < $(DEBIAN_DIR)/template/lintian-overrides > $(DEBIAN_DIR)/$(MANUAL).lintian-overrides
	for x in $(LANGS_PO); do \
		$(DEBIAN_DIR)/language $$x < $(DEBIAN_DIR)/template/control-body >> $(DEBIAN_DIR)/control; \
		$(DEBIAN_DIR)/language $$x < $(DEBIAN_DIR)/template/install > $(DEBIAN_DIR)/$(MANUAL)-$$x.install; \
		$(DEBIAN_DIR)/language $$x < $(DEBIAN_DIR)/template/doc-base > $(DEBIAN_DIR)/$(MANUAL)-$$x.doc-base; \
		$(DEBIAN_DIR)/language $$x < $(DEBIAN_DIR)/template/lintian-overrides > $(DEBIAN_DIR)/$(MANUAL)-$$x.lintian-overrides; \
	done
.PHONY: prep
#######################################################################
%:
	dh  $@

override_dh_auto_build:
	dh_auto_build -- html txt pdf "MANUAL=$(MANUAL)" \
		"LANGS_EN=$(LANGS_EN)" "LANGS_PO=$(LANGS_PO)" "LANGS=$(LANGS)" \
		"LANGS_NOPDF=$(LANGS_NOPDF)"

override_dh_auto_clean:
	dh_auto_clean

## maint-guide 1.2.32

=== Makefile ===
#######################################################################
# Build maint-guide
# vim: set ts=8:
#######################################################################
### key adjustable parameters
#######################################################################
# base file name excluding file extension
MANUAL	:=	maint-guide
# languages translated with PO files
LANGPO	:=	ca de es fr it ja ru zh-cn zh-tw
# languages to skip generation of PDF files
NOPDF	:=	zh-cn zh-tw
# languages to build document
LANGALL	=	en $(LANGPO)

VERSION := "GIT: $(shell LC_ALL=C date -u +'%F %T %Z')"

ifndef TMPDIR
TMPDIR	:= $(CURDIR)/tmp
endif

# Change $(DRAFTMODE) from "yes" to "maybe" when this document 
# should go into production mode
#DRAFTMODE      := yes
DRAFTMODE       := maybe
export DRAFTMODE
#######################################################################
### basic constant parameters
#######################################################################
# Directories (no trailing slash)
DXSL	:=	xslt
DBIN	:=	bin
DDOC	:=	doc
DPO	:=	po
DIMG	:=	/usr/share/xml/docbook/stylesheet/nwalsh/images

# Program name and option
XLINT	:=	xmllint --format
XPNO	:=	xsltproc --novalid --nonet
XPINC	:=	xsltproc --novalid --nonet --xinclude
# The threshold should be 80 if translation is completed.
THRESHOLD:=	0
TRANSLATE:=	po4a-translate  -M utf-8          --format docbook --keep $(THRESHOLD) -v 
GETTEXT	:=	po4a-gettextize -M utf-8 -L utf-8 --format docbook
UPDATEPO:=	msgmerge --update --previous
MSGATTR	:=	msgattrib
MSGCAT	:=	msgcat
DBLATEX	:=	dblatex

# English source files
DOCS	:=	$(shell ls $(DDOC)/*)
# source XML inclusion files (excluding version.ent)
ENT_STAT:=	common.ent $(addsuffix .ent, $(addprefix  $(DPO)/, $(LANGPO)))
ENT_ALL	:=	$(ENT_STAT) version.ent
# source PO files for all languages (build prcess requires these)
SRC_PO	:=	$(addsuffix .po, $(addprefix  $(DPO)/, $(LANGPO)))
# source XML files for all languages (build prcess requires these)
SRC_XML	:=	$(addsuffix .xml, $(addprefix  $(MANUAL)., $(LANGALL)))

#######################################################################
# Used as $(call check-command, <command>, <package>)
define check-command
set -e; if ! which $(1) >/dev/null; then \
  echo "Missing command: $(1), install package: $(2)"; \
  false; \
fi
endef

#######################################################################
# $ make all       # build all
#######################################################################
.PHONY: all
# set LANGPO to limit language to speed up build
all: css html txt pdf epub 

#######################################################################
# $ make test      # build html for testing (for Translator)
#######################################################################
.PHONY: test
test: html css

#######################################################################
# $ make publish   # build html text from EN.XML/PO for DDP
#######################################################################
.PHONY: package
# $(PUBLISHDIR) is set to be: /org/www.debian.org/www/doc/manuals for master-www
publish:
	-mkdir -p $(PUBLISHDIR)/$(MANUAL)
	$(MAKE) css html txt "TMPDIR=$(PUBLISHDIR)/$(MANUAL)"

#######################################################################
# $ make clean     # clean files ready for tar 
#######################################################################
.PHONY: clean
clean:
	-rm -f $(MANUAL).en.xml
	-rm -f *.swp *~ *.tmp
	-rm -f $(DPO)/*~ $(DPO)/*.mo $(DPO)/*.po.*
	-rm -rf $(TMPDIR)
	-rm -f $(addsuffix .xml, $(addprefix $(MANUAL)., $(LANGPO) en))
	-rm -f version.ent

#######################################################################
# $ make distclean # clean files to reset EN.XML/ENT/POT
#######################################################################
.PHONY: distclean
distclean: clean
	-rm -f $(DDOC)/*~
	-rm -f $(DPO)/*.pot
	-rm -f fuzzy.log

##############################################################################
# Version file preparations
##############################################################################
# version from debian/changelog
# if for www-master directly building from subversion source 
version.ent: $(DOCS)
	echo "<!ENTITY docisodate \"$(shell LC_ALL=C date -u +'%F %T %Z')\">" > version.ent
	echo "<!ENTITY docversion \"$(VERSION)\">" >> version.ent

#######################################################################
# $ make po        # update all PO from EN.XML
#######################################################################
.PHONY: po pot
pot: $(DPO)/templates.pot
po: $(SRC_PO)

# Do not record line number to avoid useless diff in po/*.po files: --no-location
# Do not update templates.pot if contents are the same as before; -I '^"POT-Creation-Date:'
$(DPO)/templates.pot: $(MANUAL).en.xml FORCE
	@$(call check-command, po4a-gettextize, po4a)
	@$(call check-command, msgcat, gettext)
	$(GETTEXT) -m $(MANUAL).en.xml | $(MSGCAT) --no-location -o $(DPO)/templates.pot.new -
	if diff -I '^"POT-Creation-Date:' -q $(DPO)/templates.pot $(DPO)/templates.pot.new ; then \
	  echo "Don't update templates.pot" ;\
	  touch $(DPO)/templates.pot ;\
	  rm -f $(DPO)/templates.pot.new ;\
	else \
	  echo "Update templates.pot" ;\
	  mv -f $(DPO)/templates.pot.new $(DPO)/templates.pot ;\
	fi
	: > fuzzy.log

# Always update
$(DPO)/%.po: $(DPO)/templates.pot FORCE
	@$(call check-command, msgmerge, gettext)
	$(UPDATEPO) $(DPO)/$*.po $(DPO)/templates.pot
	MESS1="no-obsolete  $*  `$(MSGATTR) --no-obsolete  $(DPO)/$*.po |grep ^msgid |sed 1d|wc -l`";\
	MESS2="untranslated $*  `$(MSGATTR) --untranslated $(DPO)/$*.po |grep ^msgid |sed 1d|wc -l`";\
	MESS3="fuzzy        $*  `$(MSGATTR) --fuzzy        $(DPO)/$*.po |grep ^msgid |sed 1d|wc -l`";\
	echo "$$MESS1" >>fuzzy.log ; \
	echo "$$MESS2" >>fuzzy.log ; \
	echo "$$MESS3" >>fuzzy.log ; \
	echo "" >>fuzzy.log

FORCE:

#######################################################################
# $ make wrap       # wrap all PO
#######################################################################
.PHONY: wrap nowrap wip
wrap:
	@$(call check-command, msgcat, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGCAT) -o $$XX $$XX ;\
	done
nowrap:
	@$(call check-command, msgcat, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGCAT) -o $$XX --no-wrap $$XX ;\
	done

wip:
	@$(call check-command, msgattrib, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGATTR) -o $$XX.fuzz --fuzzy        $$XX ;\
	$(MSGATTR) -o $$XX.untr --untranslated $$XX ;\
	done

#######################################################################
# $ make xml      # update all *.xml (EN.XML ...) from DOCS /ENT/PO/ADD
#######################################################################
.PHONY: xml
xml: $(SRC_XML)

$(MANUAL).en.xml: $(DOCS)
	: > $@
	for i in $(DOCS) ; do cat $$i >> $@ ; done

$(MANUAL).%.xml: $(DPO)/%.po $(MANUAL).en.xml
	@$(call check-command, po4a-translate, po4a)
	@$(call check-command, msgcat, gettext)
	if [ -f $(DPO)/$*.add ]; then \
	$(TRANSLATE) -m $(MANUAL).en.xml -a $(DPO)/$*.add -p $(DPO)/$*.po -l $(MANUAL).$*.xml ;\
	else \
	$(TRANSLATE) -m $(MANUAL).en.xml -p $(DPO)/$*.po -l $(MANUAL).$*.xml ;\
	fi
	sed -i -e 's/$(DPO)\/en\.ent/$(DPO)\/$*.ent/' $@

#######################################################################
# $ make css       # update CSS and DIMG in $(TMPDIR)
#######################################################################
.PHONY: css
css:
	-rm -rf $(TMPDIR)/images
	mkdir -p $(TMPDIR)/images
	cp -f $(DXSL)/$(MANUAL).css $(TMPDIR)/$(MANUAL).css
	echo "AddCharset UTF-8 .txt" > $(TMPDIR)/.htaccess
	cd $(DIMG) ; cp caution.png home.gif important.png next.gif note.png prev.gif tip.png up.gif warning.png $(TMPDIR)/images

#######################################################################
# $ make html      # update all HTML in $(TMPDIR)
#######################################################################
.PHONY: html
html:	$(foreach LX, $(LANGALL), $(TMPDIR)/index.$(LX).html)

$(TMPDIR)/index.%.html: $(MANUAL).%.xml $(ENT_ALL)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(TMPDIR)
	$(XPINC)   --stringparam base.dir $(TMPDIR)/ \
                --stringparam html.ext .$*.html \
                $(DXSL)/style-html.xsl $<

#######################################################################
# $ make txt       # update all Plain TEXT in $(TMPDIR)
#######################################################################
.PHONY: txt
txt:	$(foreach LX, $(LANGALL), $(TMPDIR)/$(MANUAL).$(LX).txt)

# txt.xsl provides work around for hidden URL links by appending them explicitly.
$(TMPDIR)/$(MANUAL).%.txt: $(MANUAL).%.xml $(ENT_ALL)
	@$(call check-command, w3m, w3m)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(TMPDIR)
	@test -n "`which w3m`"  || { echo "ERROR: w3m not found. Please install the w3m package." ; false ;  }
	$(XPINC) $(DXSL)/style-txt.xsl $< | \
	  LC_ALL=en_US.UTF-8 w3m -o display_charset=UTF-8 -cols 70 -dump -no-graph -T text/html > $@


#######################################################################
# $ make pdf       # update all PDF in $(TMPDIR)
#######################################################################
.PHONY: pdf
pdf:	$(foreach LX, $(LANGALL), $(TMPDIR)/$(MANUAL).$(LX).pdf)

$(foreach LX, $(NOPDF), $(TMPDIR)/$(MANUAL).$(LX).pdf):
	-mkdir -p $(TMPDIR)
	echo "PDF generation skipped." >$@

# dblatex.xsl provide work around for hidden URL links by appending them explicitly.
$(TMPDIR)/$(MANUAL).%.pdf: $(MANUAL).%.xml $(ENT_ALL)
	@$(call check-command, dblatex, dblatex)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(TMPDIR)/pdf-$*
	@test -n "`which $(DBLATEX)`"  || { echo "ERROR: dblatex not found. Please install the dblatex package." ; false ;  }
	export TEXINPUTS=".:"; \
	export TMPDIR="$(TMPDIR)/pdf-$*"; \
	$(XPINC) $(DXSL)/dblatex.xsl $<  | \
	$(DBLATEX) --style=native \
		--debug \
		--backend=xetex \
		--xsl-user=$(DXSL)/user_param.xsl \
		--xsl-user=$(DXSL)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=lingua=$* \
		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }

#######################################################################
# $ make tex       # update all TeX source in $(TMPDIR)
#######################################################################
.PHONY: tex
tex:	$(foreach LX, $(LANGALL), $(TMPDIR)/$(MANUAL).$(LX).tex)

# dblatex.xsl provide work around for hidden URL links by appending them explicitly.
$(TMPDIR)/$(MANUAL).%.tex: $(MANUAL).%.xml $(ENT_ALL)
	-mkdir -p $(TMPDIR)/tex-$*
	@test -n "`which $(DBLATEX)`"  || { echo "ERROR: dblatex not found. Please install the dblatex package." ; false ;  }
	export TEXINPUTS=".:"; \
	export TMPDIR="$(TMPDIR)/tex-$*"; \
	$(XPINC) $(DXSL)/dblatex.xsl $<  | \
	$(DBLATEX) --style=native \
		--debug \
		--type=tex \
		--backend=xetex \
		--xsl-user=$(DXSL)/user_param.xsl \
		--xsl-user=$(DXSL)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=lingua=$* \
		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }

#######################################################################
# $ make epub      # update all epub in $(TMPDIR)
#######################################################################
.PHONY: epub
epub:	$(foreach LX, $(LANGALL), $(TMPDIR)/$(MANUAL).$(LX).epub)

$(TMPDIR)/$(MANUAL).%.epub: $(MANUAL).%.xml $(ENT_ALL)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(TMPDIR)/epub-$*/
	cd $(TMPDIR)/epub-$*/ ; $(XPINC) $(CURDIR)/$(DXSL)/style-epub.xsl $(CURDIR)/$<
	cp -f $(DXSL)/mimetype $(TMPDIR)/epub-$*/mimetype
	cp -f $(DXSL)/$(MANUAL).css $(TMPDIR)/epub-$*/OEBPS/$(MANUAL).css
	cp -f $(DXSL)/debian-openlogo.png $(TMPDIR)/epub-$*/OEBPS/debian-openlogo.png
	cd $(TMPDIR)/epub-$*/ ; zip -r $@ ./

#######################################################################
### Utility targets

=== debian/changelog ===
maint-guide (1.2.32) unstable; urgency=low

  * Synch with Debian Policy 3.9.4 to introduce build-arch and 
    build-indep targets. Closes: #698717.
  * Update to current Debian Policy 3.9.5 and debhelper v9.  
    Closes: #699168
  * Updated translations: ja, fr, it, es, ca, ru, de.
    Closes: #693706, #696428, #717351
  * Removed zero width spaces from it, BOMs from ca.
  * Updated URL for wnpp-by-tags.  Closes: #701617
  * Add bash completion for dquilt. Closes: #706515
  * Typo fix. Closes: #720759, #731990, #731659
  * Split the English source in chapters. 
  * Add epub build support following the debian-reference method.

 -- Osamu Aoki <osamu@debian.org>  Mon, 06 Jan 2014 22:01:12 +0900

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MANUAL		:= maint-guide

# Languages which generate DocBook XML files from PO files
# (More conservative than the ones in Makefile)
LANGPO		:= ca de es fr it ja ru

# Override main Makefile to build CJK under sid
# No PDF build for these lunguages
LANGNOPDF	:=  

## comment out to build with the cleaner log (it slows!)
#BUILDOPT	:= --parallel
BUILDOPT	:=

VERSION		:= $(shell sed -ne '1s/[-a-zA-Z0-9 ]*(\([^()]*\)) .*$$/\1/p' debian/changelog)

#######################################################################
# If you added/removed translation, please run "debian/rules prep"
# to update the debian/control file
#######################################################################
prep:
	cd debian ;\
	cp -f control control-old ;\
	sed -e '/^Package: maint-guide-/,$$d' < control-old > control ;\
	for x in $(LANGPO); do \
		./language $$x < template/control-body >> control; \
	done
.PHONY: prep
#######################################################################
%:
	dh  $@

override_dh_auto_build:
	cd debian ;\
	./language "en" < template/install > $(MANUAL).install ;\
	./language "en" < template/doc-base > $(MANUAL).doc-base ;\
	./language "en" < template/lintian-overrides > $(MANUAL).lintian-overrides ;\
	for x in $(LANGPO); do \
		./language $$x < template/install > $(MANUAL)-$$x.install; \
		./language $$x < template/doc-base > $(MANUAL)-$$x.doc-base; \
		./language $$x < template/lintian-overrides > $(MANUAL)-$$x.lintian-overrides; \
	done
	dh_auto_build $(BUILDOPT) -- \
		"MANUAL=$(MANUAL)" \
		"VERSION=$(VERSION)" \
		"LANGPO=$(LANGPO)" \
		"LANGNOPDF=$(LANGNOPDF)" \
		all

override_dh_compress:
	dh_compress -X.pdf -X.epub

override_dh_auto_clean:
	-rm -f debian/control-old
	-rm -f debian/*.install
	-rm -f debian/*.doc-base
	-rm -f debian/*.lintian-overrides
	$(MAKE) "LANGPO=$(LANGPO)"  clean

## maint-guide 1.2.33

=== debian/changelog ===
maint-guide (1.2.33) unstable; urgency=medium

  * De-emphasize native package. Closes: #696078
  * Recommend use of cryptographic signature. Closes: #732446 
  * Always sign with debsign. Closes: #734270, #695577
  * Fixed typos. Closes: #740609, #744984 
  * Add support channel info. Closes: #719926 
  * Mention hierarchy of build commands. Closes: #703811 
  * Mention debmake and its packaging examples. Closes: #623477 
  * Translation updated for de, it, ja, and ru. Closes: #753086
  * Mention the debmake package and bump version to jessie.

 -- Osamu Aoki <osamu@debian.org>  Sat, 19 Jul 2014 16:14:04 +0900

## maint-guide 1.2.35

=== Makefile ===
--- 
+++ 
@@ -206,7 +206,9 @@
 	mkdir -p $(TMPDIR)/images
 	cp -f $(DXSL)/$(MANUAL).css $(TMPDIR)/$(MANUAL).css
 	echo "AddCharset UTF-8 .txt" > $(TMPDIR)/.htaccess
-	cd $(DIMG) ; cp caution.png home.gif important.png next.gif note.png prev.gif tip.png up.gif warning.png $(TMPDIR)/images
+	#cd $(DIMG) ; cp caution.png home.png important.png next.png note.png prev.png tip.png up.gif warning.png $(TMPDIR)/images
+	cd $(DIMG) ; cp caution.png important.png note.png tip.png up.gif warning.png $(TMPDIR)/images
+	cd png ; cp home.png next.png prev.png $(TMPDIR)/images
 
 #######################################################################
 # $ make html      # update all HTML in $(TMPDIR)
@@ -300,8 +302,3 @@
 	cd $(TMPDIR)/epub-$*/ ; $(XPINC) $(CURDIR)/$(DXSL)/style-epub.xsl $(CURDIR)/$<
 	cp -f $(DXSL)/mimetype $(TMPDIR)/epub-$*/mimetype
 	cp -f $(DXSL)/$(MANUAL).css $(TMPDIR)/epub-$*/OEBPS/$(MANUAL).css
-	cp -f $(DXSL)/debian-openlogo.png $(TMPDIR)/epub-$*/OEBPS/debian-openlogo.png
-	cd $(TMPDIR)/epub-$*/ ; zip -r $@ ./
-
-#######################################################################
-### Utility targets

=== debian/changelog ===
maint-guide (1.2.35) unstable; urgency=medium

  * Update translation: ca, es
  * Update CSS further by Stéphane Blondon.

 -- Osamu Aoki <osamu@debian.org>  Sun, 23 Nov 2014 01:55:31 +0900

maint-guide (1.2.34) unstable; urgency=medium

  * Mention wnpp-alert. Closes: #700310
  * Style fix by Helge Kreutzmann. Closes: #753319
  * Update translation: fr, jp. Closes: #755872
  * Update CSS matching other Debian pages.  Thanks, Stéphane 
    Blondon. Closes: #761611

 -- Osamu Aoki <osamu@debian.org>  Tue, 14 Oct 2014 21:29:11 +0900

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,17 @@
 Priority: optional
 Maintainer: Osamu Aoki <osamu@debian.org>
 Uploaders: Josip Rodin <joy-packages@debian.org>
-Build-Depends: debhelper (>= 8.0.0)
+Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: 
  dblatex,
  docbook-xml,
- docbook-xsl, 
+ docbook-xsl,
+ fonts-liberation, 
  po4a,
  texlive-xetex,
  texlive-lang-spanish,
  texlive-lang-french,
+ texlive-lang-german,
  texlive-lang-italian,
  texlive-lang-cyrillic,
  lmodern,
@@ -20,15 +22,15 @@
  fonts-ipafont,
  w3m,
  ghostscript, 
- xsltproc
-# texlive-lang-german,
+ xsltproc,
+ zip
 # ttf-arphic-gbsn00lp,
 # ttf-arphic-bsmi00lp,
 # ttf-wqy-zenhei,
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
+Vcs-Git: git://anonscm.debian.org/ddp/maint-guide.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=ddp/maint-guide.git
 Homepage: http://www.debian.org/doc/devel-manuals#maint-guide
-Vcs-Svn: svn://svn.debian.org/svn/ddp/manuals/trunk/maint-guide
-Vcs-Browser: http://svn.debian.org/viewsvn/ddp/manuals/trunk/maint-guide/
 
 Package: maint-guide
 Architecture: all
@@ -77,6 +79,31 @@
  .
  This is Catalan translation.
 
+Package: maint-guide-de
+Architecture: all
+Priority: extra
+Depends: ${misc:Depends}
+Suggests: doc-base, dh-make, devscripts, fakeroot, lintian, dupload | dput, debian-policy, developers-reference, pbuilder, quilt
+Description: Debian New Maintainers' Guide (German)
+ This package contains the Debian New Maintainers' Guide.
+ .
+ This document tries to describe the building of a Debian package to ordinary
+ Debian users and prospective developers. It uses fairly non-technical
+ language, and it's well covered with working examples.
+ .
+ The document contains these chapters:
+     * 1 Getting started The Right Way
+     * 2 First steps
+     * 3 Modifying the source
+     * 4 Required files under debian directory
+     * 5 Other files under debian directory
+     * 6 Building the package
+     * 7 Checking the package for errors
+     * 8 Uploading the package
+     * 9 Updating the package
+ .
+ This is German translation.
+
 Package: maint-guide-es
 Architecture: all
 Priority: extra
